	SUBROUTINE AUXINI
	INCLUDE 'NETMIN/NOLIST'
	LOGICAL*1 REGIS(11)
C
C	Turn off graphics cursor and enter REGIS mode.
C
	DATA REGIS/27,'P','r','V','C','1',27,'\',27,'P','p'/
	PIXROW=12
	PIXCOL=12
	IF (GIGI) TYPE 90, REGIS
90	FORMAT($,'+',9A1)
	IF (GIGI) TYPE 100
100	FORMAT($,'+;S(I(D)N0AE)W(VI(R)A0S0M1N0P1M2)T(I0A0D0S1)P[0,0]')
	RETURN
	END
	SUBROUTINE AUXBOX(NODE,ROW,COL,H,W)
	INCLUDE 'NETMIN/NOLIST'
C
C	Draw a solid box with top left corner at (ROW,COL)
C
	INTEGER*4 COLOR
	TOPBAR=(ROW-1)*PIXROW+HOKLDG
	BOTBAR=(TOPBAR-HOKLDG)+H*PIXROW-2-HOKLDG
	BOXWID=W*PIXCOL-1
	TOPCOL=(COL-1)*PIXCOL
	COLOR='BLUE'
	IF (KNOWN(NODE)) COLOR='RED'
	IF (NODE.EQ.1) COLOR='R'	! RED
	IF (NODE.EQ.2) COLOR='Y'	! YELLOW
	IF (NODE.EQ.3) COLOR='G'	! GREEN
	IF (NODE.EQ.4) COLOR='B'	! BLUE
	IF (NODE.EQ.5) COLOR='M'	! MAGENTA (PURPLE)
	IF (.NOT. WANTED(NODE)) GOTO 300
	IF (GIGI) TYPE 200, TOPCOL,BOTBAR,COLOR,TOPCOL,TOPBAR,BOXWID
200	FORMAT(' P[',I3,',',I3,']','W(I(',A1,'))',
     X	'W(S1)P[',I3,',',I3,']V[+',I3,',]W(S0)')
	S=NAMSIZ(NODE)*SCALE
	SI=NAMSIZ(NODE)
	ADJS=S*5/6
	MIDCOL=TOPCOL+(W-ADJS)*PIXCOL/2
	IF (GIGI) TYPE 201, MIDCOL, (TOPBAR+BOTBAR)/2-7,SCALE,
     X	(NAME(NODE,J),J=1,SI)
201	FORMAT(' P[',I3,',',I3,']W(C)',
     X	'T(S',I1,')"',<SI>A1,'"W(V)')
	RETURN
300	S=5*SCALE
	ADJS=S*5/6
	MIDCOL=TOPCOL+(W-ADJS)*PIXCOL/2
	IF (GIGI) TYPE 301, MIDCOL, (TOPBAR+BOTBAR)/2-7,SCALE,
     X	MASLOC(1,NODE), MASLOC(2,NODE)
301	FORMAT(' P[',I3,',',I3,']W(I(W))',
     X	'T(S',I1,')"to ',2A1,'"W(I(D))')
	RETURN
	END
	SUBROUTINE AUXLIN(X1,Y1,X2,Y2)
	INCLUDE 'NETMIN/NOLIST'
	IF (GIGI) TYPE 300, X1,Y1,X2,Y2
300	FORMAT(' P[',I3,',',I3,']',
     X	'W(I(W))V[',I3,',',I3,']')
	RETURN
	END
	SUBROUTINE AUX12(LROW,LCOL,RROW,RCOL)
	INCLUDE 'NETMIN/NOLIST'
	LX=LCOL*PIXCOL-1
	LY=(LROW-1)*PIXROW+PIXROW/2
	RX=(RCOL-1)*PIXCOL-1
	RY=(RROW-1)*PIXROW+PIXROW/2
	CALL AUXLIN(LX,LY,RX,RY)
	RETURN
	END
	SUBROUTINE AUX13(LROW,LCOL,RROW,RCOL)
	INCLUDE 'NETMIN/NOLIST'
	LX=(2*LCOL-4+BOXW-2)*PIXCOL/2	! NOT SURE WHY -2 AT END
	LY=LROW*PIXROW-1-HOKLDG
	RX=(2*RCOL-4+BOXW-2)*PIXCOL/2	! DITTO
	RY=(RROW-1)*PIXROW-1+HOKLDG
	CALL AUXLIN(LX,LY,RX,RY)
	RETURN
	END
	SUBROUTINE AUX14(LROW,LCOL,RROW,RCOL)
	INCLUDE 'NETMIN/NOLIST'
	LX=LCOL*PIXCOL-1
	LY=LROW*PIXROW-1-HOKLDG
	RX=(RCOL-1)*PIXCOL
	RY=(RROW-1)*PIXROW-1+HOKLDG
	CALL AUXLIN(LX,LY,RX,RY)
	RETURN
	END
	SUBROUTINE AUX23(LROW,LCOL,RROW,RCOL)
	INCLUDE 'NETMIN/NOLIST'
	LX=(LCOL-1)*PIXCOL
	LY=LROW*PIXROW-1-HOKLDG
	RX=RCOL*PIXCOL-1
	RY=(RROW-1)*PIXROW-1+HOKLDG
	CALL AUXLIN(LX,LY,RX,RY)
	RETURN
	END
	SUBROUTINE AUXHKU(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL-1+PIXCOL/2
	Y=(ROW-1)*PIXROW-2
	IF (Y-2.GE.0) CALL AUXLIN(X,Y-2,X,Y+HOKLDG)
	RETURN
	END
	SUBROUTINE AUXHKD(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL-1+PIXCOL/2
	Y=ROW*PIXROW
	CALL AUXLIN(X,Y+2,X,Y-HOKLDG)
	RETURN
	END
	SUBROUTINE AUXHB(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL-1
	Y=(ROW-1)*PIXROW+PIXROW/2
	CALL AUXLIN(X,Y,X+PIXCOL,Y)
	RETURN
	END
	SUBROUTINE AUXVB(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=(ROW-1)*PIXROW-1
	CALL AUXLIN(X,Y,X,Y+PIXROW)
	RETURN
	END
	SUBROUTINE AUXUL(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=(ROW-1)*PIXROW+PIXROW/2
	CALL AUXLIN(X,Y+PIXROW/2,X,Y)
	CALL AUXLIN(X,Y,X+PIXCOL/2-1,Y)
	RETURN
	END
	SUBROUTINE AUXUR(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=(ROW-1)*PIXROW+PIXROW/2
	CALL AUXLIN(X,Y+PIXROW/2,X,Y)
	CALL AUXLIN(X,Y,X-PIXCOL/2,Y)
	RETURN
	END
	SUBROUTINE AUXLL(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=(ROW-1)*PIXROW+PIXROW/2
	CALL AUXLIN(X,Y-PIXROW/2-1,X,Y)
	CALL AUXLIN(X,Y,X+PIXCOL/2-1,Y)
	RETURN
	END
	SUBROUTINE AUXLR(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=(ROW-1)*PIXROW+PIXROW/2
	CALL AUXLIN(X,Y-PIXROW/2-1,X,Y)
	CALL AUXLIN(X,Y,X-PIXCOL/2,Y)
	RETURN
	END
	SUBROUTINE AUXTD(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=ROW*PIXROW
	CALL AUXLIN(X,Y,X,Y-HOKLDG)
	RETURN
	END
	SUBROUTINE AUXTU(ROW,COL)
	INCLUDE 'NETMIN/NOLIST'
	X=(COL-1)*PIXCOL+PIXCOL/2
	Y=(ROW-1)*PIXROW-1
	CALL AUXLIN(X,Y,X,Y+HOKLDG)
	RETURN
	END
	SUBROUTINE AUXEND
	INCLUDE 'NETMIN/NOLIST'
	LOGICAL*1 REGOUT(2)
	DATA REGOUT /27,'\'/
	LOGICAL*1 L
C	IF (GIGI) ACCEPT 50, L
C50	FORMAT(A1)
	IF (GIGI) TYPE 100
100	FORMAT($,'+;S(I0N0A)W(VI7A0S0M1N0P1M2)T(I0A0D0S1)P[0,0]')
	IF (GIGI) TYPE 200, REGOUT
200	FORMAT('+S(I(D))',2A1,$)
	ROW=23
	IF (ETHER) ROW=22
	IF (GIGI) CALL LIB$SET_CURSOR(ROW,1)
	RETURN
	END
