$!---------------------------------------------------------------------
$!           WHOSYS Command -  By Scott B. Sibley   20 MAR 81
$!---------------------------------------------------------------------
$!
$! Show Active VAX Users:  WHOSYS [process-prefix][-COL[-OUT]]|-PACK|-F|-H
$!
$!     GLOBAL SYMBOLS used:  UtilityDir, TempDir, HelpDir, Out
$!     FILES used:  "TempDir"ZZ.WHO, WHOSYS.LIS, "HelpDir"whosys.hlp
$!
$!---------------------------------------------------------------------
$!---------------------------------------------- Process option
$      userID := ""
$      outfile := "TT:"
$      LFprog := "LF"
$      opt := ""
$      arg = 0
$Next:    arg = arg + 1
$         it := ""
$         IF arg .EQ. 1 THEN it := "''P1'"
$         IF arg .EQ. 2 THEN it := "''P2'"
$         IF arg .EQ. 3 THEN it := "''P3'"
$         IF it .EQS. "" THEN GOTO DelSym
$         IF "''F$EXT(0,1,it)'" .EQS. "-" THEN GOTO TryOpt
$            userID := "''it'"
$            GOTO Next
$TryOpt:  opt := 'F$EXT(0,2,it)'
$         IF opt .EQS. "-F" .OR. opt .EQS. "-H" THEN GOTO INFO
$         last = "''F$LOC(":",it)'" + 1
$         IF opt .EQS. "-O" THEN outfile := "''F$EXT(last,99,it)'"
$         IF opt .EQS. "-P" THEN LFprog := "''F$EXT(last,99,it)'"
$         IF opt.EQS."-C".OR.opt.EQS."-O".OR.opt.EQS."-P" THEN GOTO Next
$            Out "       WHOSYS - Invalid Option:  ''it'"
$            EXIT
$DelSym:DEL/SYMBOL/LOC arg
$!---------------------------------------------- Check Options
$      IF outfile .EQS. "TT:" THEN GOTO OptOK
$      IF outfile .EQS. "" THEN outfile := "WHOSYS.LIS"
$      OPEN/WRIT/ERR=NoOut WHOLIST 'outfile'
$      GOTO OptOk
$NoOut:   Out "       WHOSYS - Cannot open Output file:  ",outfile
$         EXIT
$OptOK:
$      IF LFprog .EQS. "" THEN LFprog := "LFPACK"
$!------------------------------------------------ Get Temp File
$      proc := "''F$PROC()'"     !  Try to get User's name
$      IF "''F$EXT(0,1,proc)'" .EQS. "_" THEN proc := ZZ
$      TempFile := "''TempDir'''proc'.WHO"
$!-----------------------------------------------
$      IF userID .NES. "" THEN opt := "-C"
$      IF opt.NES."" .AND. opt.NES."-P" THEN GOTO Column
$!------------------------------------------------ Create Condensed List
$      ASSI/USER_MODE 'TempFile' SYS$OUTPUT
$      SHOW SYSTEM
$      OPEN/ERR=NoDir FOR001 'TempFile'
$Good: ON Control_Y THEN GOTO Quit
$      ON Warning THEN GOTO Quit
$      OPEN/WRITE/ERR=NoDir NEWLIST 'TempFile'
$ReadWHO:
$         READ/END=WHOEOF FOR001 Line
$         proc := "''F$EXT(11,14,Line)'"
$         IF proc .EQS. "NULL" THEN GOTO ReadWHO
$         IF proc .EQS. "SWAPPER" THEN GOTO ReadWHO
$         IF proc .EQS. "ERRFMT" THEN GOTO ReadWHO
$         IF proc .EQS. "OPCOM" THEN GOTO ReadWHO
$         IF proc .EQS. "JOB_CONTROL" THEN GOTO ReadWHO
$         IF proc .EQS. "DBA0ACP" THEN GOTO ReadWHO
$         IF proc .EQS. "PRTSYMB1" THEN GOTO ReadWHO
$         WRITE NEWLIST "''F$EXTR(11,14,Line)'"
$         GOTO ReadWHO
$WHOEOF:
$      CLOSE NEWLIST
$      CLOSE FOR001
$!------------------------------------------------ Print Condensed List
$      OPEN/ERR=NoDir FOR001 'TempFile'
$      RUN 'UtilityDir''LFprog'
$Quit: ON Control_Y THEN EXIT
$      ON Warning THEN EXIT
$Close:CLOSE FOR001
$      GOTO Del
$!------------------------------------------------ Print Full List
$Column:
$      Echo := WR SYS$OUTPUT
$      IF outfile .NES. "TT:" THEN Echo := WR WHOLIST
$      ON Control_Y THEN GOTO EOF
$      ON Warning THEN GOTO EOF
$      ASSI/USER_MODE 'TempFile' SYS$OUTPUT
$      SHOW SYSTEM
$      OPEN WHOFILE 'TempFile'
$      NotFound = 1
$      READ/END=READ WHOFILE Line
$      READ/END=READ WHOFILE Title
$      namelen = 'F$LEN(userID)'
$READ: READ/END=EOF WHOFILE Line       ! Line has CR,LF at front
$      procname := "''F$EXTR(11,namelen,Line)'"
$      IF userID .NES. "" .AND. userID .NES. procname THEN GOTO Read
$         IF NotFound THEN Echo "''F$EXTR(11,99,Title)'"
$         NotFound = 0
$         Echo "''F$EXTR(11,99,Line)'"      !  User Entry
$      GOTO READ
$EOF:  CLOSE WHOFILE
$      IF NotFound THEN Out "       WHOSYS - ""''userID'"" Not Logged On"
$Del:  DELETE 'TempFile';*
$      IF outfile .NES. "TT:" THEN CLOSE WHOLIST
$NoDir:EXIT
$!------------------------------------------------
$INFO: Out "       Show Active VAX Users:  WHOSYS [process-prefix]",-
                "[-COL[-OUT]]|-PACK|-F|-H"
$      IF opt .NES. "-F" THEN fmt 'HelpDir'whosys.hlp TT:
