$!--------------------------------------------- Miscellaneous Symbols
$  V :== SH SYM
$  Out :== WR SYS$OUTPUT
$!--------------------------------------------- Directory Path Symbols
$  InfoDir :== DB0:[CONTRERAS.UTIL.INFO]
$  UtilityDir :== DB0:[CONTRERAS.UTIL]
$  HelpDir :== DB0:[CONTRERAS.UTIL.HELP]
$  NewsDir :== DB0:[CONTRERAS.NEWS]
$  LSErrDir :== DB0:[CONTRERAS.LSERRCODE]
$  ComSubDir :== DB0:[CONTRERAS.COMSUBS]
$  InSubDir  :== DB0:[CONTRERAS.COMSUBS.IN]
$  OutSubDir :== DB0:[CONTRERAS.COMSUBS.OUT]
$  CmdInterpDir :== DB0:[CONTRERAS.COMSUBS.CMDI]
$!--------------------------------------------- Directory Path for Temp
$  TempDir :== DB0:[CONTRERAS.UTIL]
$  group := "''F$USER()'"
$  group := "''F$EXT(1,3,group)'"
$  IF group.NES."200" .AND. group.NES."232" THEN TempDir :== "''F$DIR()'"
$!--------------------------------------------- Saved File-Name/Directory
$  SaveFile :== LOGIN.COM
$  What :== 'Out' """         SaveFile:  """, SaveFile
$  SaveDir :== [CONTRERAS]
$!--------------------------------------------- Functions
$  GetTopDir :== @'UtilityDir'TopDir     ! () RETURNS TopDir
$  GetPathName :== @'UtilityDir'GetPath  ! (file-spec) RETURNS PathName
$  SetDefFileType :==@'UtilityDir'SetFilTyp! (file,"typ") RETURNS FileSpec
$! GetHomeDir :== @'UtilityDir'HomeDir   ! () RETURNS HomeDir
$!--------------------------------------------- LSMOC Directory Paths
$  LSMOCHelpDir :== [CONTRERAS.LSMOC.CMD.HELP]
$  LSMOCAccFormCodeDir :== [CONTRERAS.LSMOC.AF.CODE]
$  LSMOCAccFormDataDir :== [CONTRERAS.LSMOC.AF.DATA]
$!--------------------------------------------- LSMOC Commands
$  POST :== @'UtilityDir'POST
$  AFEDIT :== @'LSMOCAccFormCodeDir'AFEDIT
$!--------------------------------------------- Commands: BMDP
$  BMDP :== @DBA0:[BMDP]BMDP
$  BMDPT :== @DBA0:[BMDP]BMDPT
$  BIMED :== @DBA0:[BMDP]BIMED
$!--------------------------------------------- Commands: Experimental
$  Talk :== RUN SYS$SYSTEM:TALK
$  TECO :== $SYS$SYSTEM:TECO TECO
$  TOC :== RUN SYS$SYSTEM:TOC
$  TCX :== RUN SYS$SYSTEM:TCX
$  NDXDMP :== RUN SYS$SYSTEM:NDXDMP
$  Sea*rch :== RUN SYS$SYSTEM:SEARCH
$  SetP*roc :== RUN SYS$SYSTEM:SETNAME
$  Us*ers :== RUN SYS$SYSTEM:USERS
$!--------------------------------------------- Commands: List
$  FILEPRT :== @'UtilityDir'FILEPRT
$  FILETYP :== @'UtilityDir'FILETYP
$  PG :== @'UtilityDir'PG
$!--------------------------------------------- Commands: NEWS
$  NEWS :== @'NewsDir'NEWS
$  Publish :== @'NewsDir'PUBLISH
$  SysNews :== 'PG' DB0:[SYSMGR]SYSNEWS.DAT
$  OldMail :== @'UtilityDir'MAIL
$!--------------------------------------------- Commands: SIBLEY
$  RENUM :== R DB0:[SIBLEY.UTIL]R
$  FLX :== @DB0:[SIBLEY.UTIL.FLEX]FLECS
$  CEN :== @DB0:[SIBLEY.UTIL]CEN
$  FMT :== @DB0:[SIBLEY.UTIL.FMT]FMT
$!--------------------------------------------- Commands: Directory
$  Tree :== @'UtilityDir'Tree
$  FreeDir :== SET PROT=(O:RWED,W:RWED)
$  MkDir :== @'UtilityDir'MkDir
$  WH*ERE :== @'UtilityDir'GETWHERE
$  CD :== @'UtilityDir'CD
$  LF :== @'UtilityDir'LF
$!--------------------------------------------- Commands: Utility
$  REW :== SET MAGTAPE/REWIND
$  WHOIS :== @'UtilityDir'WHOIS
$  WHOSYS :== @'UtilityDir'WHOSYS
$  Syms :== @'UtilityDir'SYMS
$  Source :== @'UtilityDir'SOURCE
$  Info :== @'UtilityDir'INFO
$  SAVE :== @'UtilityDir'SAVE
$  LSLINK :== @'LSErrDir'LSLINK
$  GenFLX :== @'UtilityDir'GENFLX
$  KILL :== @'UtilityDir'KILL
$!--------------------------------------------- Commands: Edit
$  SE :== @'UtilityDir'SE        ! Multi-file MCR Editor
$  E :== @'UtilityDir'E          ! Multi-file SOS Editor
$  EEF :== @[SIBLEY.UTIL.EDIT]EEF  ! Scott Sibley's Editor (Fast)
$  EE :== @[SIBLEY.UTIL.EDIT]EE  ! Scott Sibley's Editor
$!--------------------------------------------- Initialize Status
$  IF "''F$EXTR(0,1,group)'" .EQS. "3" THEN EXIT
$  SET PROT=(S:RE,G:RE)/DEFAULT
$  SET MESSAGE /NOFAC/NOSEVER/NOID
$  @'NewsDir'CheckNEWS
