$!	**** CLOSEACT.COM ****
$!
$!   This command proc. is designed to close out the accounting file at the
$!   end of each day and to wait for 24 hours to do it again the next
$!   day.  At the end of each month, the system manager will run a
$!   program to compute the actual charges to the individual accounts.
$!
$ ASSIGN NL: SYS$PRINT				! Stop log file from printing
$!
$ DATA_DIR := "DISK$SYSTEM:[SYSMGR.ACCOUNT.FY81]"
$ MONTH_DIR:= "DISK$SYSTEM:[SYSMGR.ACCOUNT.FY81.MON03MAR]"
$ DISK_DIR := 'MONTH_DIR'
$!
$!	Rename the accounting file
$!
$ RENAME DISK$SYSTEM:[SYSMGR]ACCOUNTNG.DAT 'MONTH_DIR'ACCOUNTNG.OLD
$!
$!	Close the old accounting file
$!
$ SET ACCOUNTING/NEW
$!
$!	Append the old file to the master file for the current year
$!
$ APPEND 'MONTH_DIR'ACCOUNTNG.OLD 'DATA_DIR'ACCOUNTNG.F81/LOG/WR
$!
$!	Calculate the amount of disk space in use
$!
$ @DISK$SYSTEM:[SYSMGR.ACCOUNT]DISKSPACE.COM
$!
$!	Resubmit this job to run at midnite
$!
$ SUBMIT DISK$SYSTEM:[SYSMGR.ACCOUNT]CLOSEACT.COM/QUEUE=SYSTEM-
	/AFTER=TOMORROW
$!
$ EXIT_ALL:
$!
$	DELETE CLOSEACT.LOG;*/LOG
$	EXIT
