$!---------------------------------------------------------------------
$!             CD Command -  By Scott B. Sibley   29 Sept 80
$!---------------------------------------------------------------------
$!
$!   Change Dir:  CD [[<]local-dir | >path | -PREV | -F | -H] {home}
$!
$!     GLOBAL SYMBOLS used:  SaveDir, HelpDir, GetTopDir, TopDir
$!     FILES used:  'HelpDir'cd.hlp
$!
$!---------------------------------------------------------------------
$      ON ERROR THEN EXIT
$      ON Control_Y THEN CONTINUE
$      NowPath := "''F$DIR()'"
$      it := "''F$EXT(0,1,P1)'"
$      IF it .NES. "-" THEN GOTO NoOpt
$      it := "''F$EXT(0,2,P1)'"
$      IF it .EQS. "-T" THEN GOTO Top
$      IF it .NES. "-P" THEN GOTO INFO
$!---------------------------------------------- Change to Previous Dir
$      SET DEF 'SaveDir'
$      GOTO Save
$!---------------------------------------------- Check Request
$NoOpt:IF it .EQS. "" THEN GOTO Home
$!---------------------------------------------- Get Directory Names
$      pt := "''P1'"
$      IF it.EQS."\".OR.it.EQS."<".OR.it.EQS.">" THEN pt:='F$EXT(1,80,pt)
$      IF 'F$LOC("[",pt) .NE. 'F$LEN(pt) THEN SET DEF 'pt'
$      IF 'F$LOC("[",pt) .NE. 'F$LEN(pt) THEN GOTO Save
$!---------------------------------------------- Check Path Direction
$      IF it .EQS. "\" THEN GOTO Up1
$      IF it .EQS. "<" THEN GOTO Up1
$      IF it .EQS. ">" THEN GOTO Path
$!---------------------------------------------- Change Directory down
$      last = 'F$LEN(NowPath) - 1
$      SET DEF 'F$EXT(0,last,NowPath).'pt']
$      GOTO Save
$!---------------------------------------------- Change to Top Directory
$Top:  GetTopDir
$      SET DEF 'TopDir']
$      GOTO Save
$!---------------------------------------------- Change to Home Directory
$Home: it := "''F$PROC()'"
$      IF "''F$EXT(0,1,it)" .EQS. "_" THEN GOTO NoHome
$      SET DEF ['it]
$      GOTO Save
$NoHome: Out "         Home Directory unknown:  ",it
$      EXIT
$!---------------------------------------------- Change Directory up 1
$Up1:  IF 'F$LOC(".",NowPath) .NE. 'F$LEN(NowPath) THEN GOTO GetPrev
$      Out "         At top directory:  ", NowPath
$      EXIT
$GetPrev:
$      str := "''NowPath'"
$      len = 0
$Scan: loc = 'F$LOC(".",str) + 1
$      IF loc .GT. 'F$LEN(str) THEN GOTO SetUp
$      len = len + loc
$      str := "''F$EXT(loc,80,str)'"
$      GOTO Scan
$SetUp:IF pt .NES. "" THEN GOTO SetUpNext
$      len = len - 1
$      SET DEF 'F$EXT(0,len,NowPath)]
$      GOTO Save
$SetUpNext: SET DEF 'F$EXT(0,len,NowPath)''pt']
$      GOTO Save
$!---------------------------------------------- Change Directory to Path
$Path: SET DEF ['pt]
$!---------------------------------------------- Save Previous Dir Path
$Save: SaveDir :== "''NowPath'"
$      EXIT
$!---------------------------------------------- Print Help
$INFO:
$Out "       Change Directory:  CD [[<]local-dir | >path | -PREV | -F | -H] {home}"
$      IF "''F$EXT(0,2,P1)'" .NES. "-F" THEN fmt 'HelpDir'cd.hlp TT:
