$!Procedure to build VAX Sig Spring 1981 Library from Tape
$!
$! Tape must be allocated with logical name RSTTAP
$! Files and Subdirectories are put in current directory.
$!
$ D1:='F$DIRECTORY()
$ D2='F$LENGTH(D1)'-1
$ ROOT_DIR:='F$EXTRACT(0,D2,D1)
$ BACK_TO_ROOT:=SET DEFAULT 'D1
$ DISMOUNT/NOUNLOAD RSTTAP:
$ MOUNT/NOWRITE RSTTAP: VAXS81		! TO REWIND TAPE
$
$ SHOW DEFAULT
$ BACK_TO_ROOT
$
$ COPY RSTTAP:AAAREADME.DOC *
$ COPY RSTTAP:AAAREADME.RNO *
$ COPY RSTTAP:RESTORE.COM *
$ COPY RSTTAP:TAPEBUILD.COM *
$ COPY RSTTAP:MTCOPY.EXE *
$ COPY RSTTAP:TPCPY.EXE *
$
$ CREATE/DIRECTORY 'ROOT_DIR'.ACCNTNG]
$ SET DEFAULT [.ACCNTNG]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:ACCNTNG.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.APL]
$ SET DEFAULT [.APL]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:APL.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.ASM6502]
$ SET DEFAULT [.ASM6502]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:ASM6502.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.DECNET]
$ SET DEFAULT [.DECNET]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:DECNET.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.DPY]
$ SET DEFAULT [.DPY]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:DPY.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.EDITOR]
$ SET DEFAULT [.EDITOR]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:EDITOR.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FILELIST]
$ SET DEFAULT [.FILELIST]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:FILELIST.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO]
$ SET DEFAULT [.FORDAERO]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:FORDAERO.CON
$ BACK_TO_ROOT
$
$!
$ SET PROTECTION=OW:RWED 'ROOT_DIR'.FORDAERO]*.DIR.*
$ DELETE 'ROOT_DIR'.FORDAERO]*.DIR.*
$!
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.BMDP]
$ SET DEFAULT [.FORDAERO.BMDP]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:BMDP.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.CMD]
$ SET DEFAULT [.FORDAERO.CMD]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:CMD.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.EDITOR]
$ SET DEFAULT [.FORDAERO.EDITOR]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:EDITOR.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.FLX]
$ SET DEFAULT [.FORDAERO.FLX]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:FLX.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.FMT]
$ SET DEFAULT [.FORDAERO.FMT]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:FMT.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.HELP]
$ SET DEFAULT [.FORDAERO.HELP]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:HELP.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.INFO]
$ SET DEFAULT [.FORDAERO.INFO]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:INFO.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORDAERO.NEWS]
$ SET DEFAULT [.FORDAERO.NEWS]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:NEWS.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.FORTTOOLS]
$ SET DEFAULT [.FORTTOOLS]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:FORTTOOLS.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.GAMES]
$ SET DEFAULT [.GAMES]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:GAMES.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.LBLTOOLS]
$ SET DEFAULT [.LBLTOOLS]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:LBLTOOLS.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.MISCUTIL]
$ SET DEFAULT [.MISCUTIL]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:MISCUTIL.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.NCAR]
$ SET DEFAULT [.NCAR]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:NCAR.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.REALTREK]
$ SET DEFAULT [.REALTREK]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:REALTREK.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.SYSMGR]
$ SET DEFAULT [.SYSMGR]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:SYSMGR.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.TAPEUTIL]
$ SET DEFAULT [.TAPEUTIL]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:TAPEUTIL.CON
$ BACK_TO_ROOT
$
$ CREATE/DIRECTORY 'ROOT_DIR'.VPLOT]
$ SET DEFAULT [.VPLOT]
$ SHOW DEFAULT
$ MCR RST *.*;*/FR=RSTTAP:VPLOT.CON
$ BACK_TO_ROOT
$
$ EXIT
