$!
$!  Create the autobaud control process
$ON ERROR THEN $GOTO ERR_EXIT
$ run/process_name=auto_baud BAT$SYSTEM:BAUD-
/uic=[001,004]-
/ast_limit=50-
/file_limit=50-
/io_buffered=50-
/queue_limit=50-
/page_file=1000-
/subprocess_limit=0-
/priority=14-
/privileges=(phy_io)-
/OUT=SYS$BOOT:[SYSMGR]BAUD.LOG
$!
$!  Send the configuration data to the autobaud process
$WAIT 00:00:30
$COPY SYS$BOOT:[SYSMGR]BAUDLIST.DAT  BAUD_OPER_MBX
$EXIT
$!
$!  Here if error opening any file
$ERR_EXIT:
$WRITE SYS$ERROR "ERROR"
$WRITE SYS$ERROR "ERROR - AUTO_BAUD initialization failed."
$WRITE SYS$ERROR "ERROR"
$EXIT
$!++
$!  Title:
$!	RUNBAUD.COM - Initiate autobaud terminal control
$!
$!  Facility:
$!	System startup procedure.
$!
$!  Abstract:
$!	This command procedure is submitted from SYSTARTUP.COM to initiate
$!	autobaud terminal handling.  The terminal configuration is read
$!	from the file SYS$BOOT:[SYSMGR]BAUDLIST.DAT.
$!
$!  Environment:
$!	DCL command interpreter. Intended to be run from SYSTARTUP.COM
$!
$!  Author: 
$!	Gary L. Grebus, Creation date: 1-March-1981
$!	Battelle Columbus Labs
$!
$!  Modified by:
$!
$!
$!--
